/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __GDAM_RESAMPLE_H_
#define __GDAM_RESAMPLE_H_

typedef struct _GdamResample GdamResample;

#include "gdamfilter.h"

typedef GdamFilterClass GdamResampleClass;


GtkType gdam_resample_get_type();
#define GDAM_TYPE_RESAMPLE   gdam_resample_get_type()
#define GDAM_RESAMPLE(ptr) ((GdamResample*) gtk_type_check_object_cast ((GtkTypeObject*) (ptr), GDAM_TYPE_RESAMPLE))

struct _GdamResample {
	GdamFilter           filter;

	/* This is the rate with 32bits of fraction. */
	guint64			rate;


	/* Specifies what the last sample read was,
	 * and how much is carrying over... */
	GdamSample		last_sample;

	/* In interpolating mode, this is used in conjunction
	 * w/ last_sample... */
	GdamSample		cur_sample;
	/*
	   this value is the fractional
	   number of samples we have output
           with last_sample.
	 */
	guint32			accum;

	gboolean		interpolating;

	/* Last time, the number of whole samples that were skipped. */
	int			last_skipped;

};

#if 0
void        gdam_resample_set_rate     (GdamResample*   resample,
                                        GdamFixed       fixed);
#endif

#endif
