/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __GDAM_SEEKABLE_MP3_H__
#define __GDAM_SEEKABLE_MP3_H__

typedef struct _GdamSeekableMp3 GdamSeekableMp3;
typedef struct _GdamSeekableMp3Class GdamSeekableMp3Class;

#include "gdamproxysource.h"

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */


GtkType gdam_seekable_mp3_get_type();
#define GDAM_TYPE_SEEKABLE_MP3              (gdam_seekable_mp3_get_type ())
#define GDAM_SEEKABLE_MP3(obj)              (GTK_CHECK_CAST ((obj), GDAM_TYPE_SEEKABLE_MP3, GdamSeekableMp3))
#define GDAM_SEEKABLE_MP3_CLASS(klass)      (GTK_CHECK_CLASS_CAST ((klass), GDAM_TYPE_SEEKABLE_MP3, GdamSeekableMp3Class))
#define GDAM_IS_SEEKABLE_MP3(obj)           (GTK_CHECK_TYPE ((obj), GDAM_TYPE_SEEKABLE_MP3))
#define GDAM_IS_SEEKABLE_MP3_CLASS(klass)   (GTK_CHECK_CLASS_TYPE ((klass), GDAM_TYPE_SEEKABLE_MP3))

struct _GdamSeekableMp3 {
	GdamProxySource		proxy_source;
	char*			filename;
	GdamTime                stopped_position;
	GdamTime		stopped_length;

	int			buffer_size;
};

GdamSeekableMp3* gdam_seekable_mp3_new          (const char*   filename,
                                                 GdamTime      start);
void             gdam_seekable_mp3_seek_start   (GdamSeekableMp3* mp3,
                                                 GdamTime      samples);
void             gdam_seekable_mp3_seek_relative(GdamSeekableMp3* mp3,
                                                 GdamTime      samples);
void             gdam_seekable_mp3_seek_absolute(GdamSeekableMp3* mp3,
                                                 GdamTime      samples);

#ifdef __cplusplus
}
#endif /* __cplusplus */


#endif
